VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   Caption         =   "Snow"
   ClientHeight    =   2664
   ClientLeft      =   60
   ClientTop       =   348
   ClientWidth     =   8028
   BeginProperty Font 
      Name            =   "Comic Sans MS"
      Size            =   24
      Charset         =   204
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   ScaleHeight     =   2664
   ScaleWidth      =   8028
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   870
      Top             =   1860
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Dim bRUN As Boolean

Dim fMouseDown_X As Single
Dim fMouseDown_Y As Single
Dim bMOUSE_DOWN As Boolean

Private Sub Form_Load()
    
    Randomize
    
    Me.ScaleMode = vbPixels
    Me.DrawWidth = PSIZE
    Me.BackColor = vbBlack
    
    
    Dim i As Integer
    
    ' The RND formula!
    ' Int((upperbound - lowerbound + 1) * Rnd + lowerbound)

    For i = 0 To MAXP
        Snow(i).X = CInt(Int(Me.ScaleWidth * Rnd))
        Snow(i).Y = CInt(Int(Me.ScaleHeight * Rnd))
    Next i
    
    bRUN = True
    Timer1.Enabled = True

    ' Center and draw the text:
    Const sTEXT = "  "
    Me.ForeColor = vbRed
    Me.CurrentX = Me.ScaleWidth / 2 - TextWidth(sTEXT) / 2
    Me.CurrentY = Me.ScaleHeight / 2 - TextHeight(sTEXT) / 2
    Me.Print sTEXT

    Me.ForeColor = vbWhite
    
End Sub

Sub DrawSnow()
    Dim i As Integer
    
    Dim newX As Integer
    Dim newY As Integer
    
    Timer1.Enabled = False
    
Do While bRUN
    
    For i = 0 To MAXP
       Me.PSet (Snow(i).oldX, Snow(i).oldY), vbBlack
       Me.PSet (Snow(i).X, Snow(i).Y)
    Next i
    
    For i = 0 To MAXP
       Snow(i).oldX = Snow(i).X
       Snow(i).oldY = Snow(i).Y
             
       ' A trick to get both positive and negative random values:
       newX = Snow(i).X + Int(2 * Rnd)
       newX = newX - Int(2 * Rnd)
       
       ' Don't alow our snow to run away:
       If newX < 0 Then newX = 0
       If newX >= Me.ScaleWidth Then newX = Me.ScaleWidth - 1
       
       newY = Snow(i).Y + 1
       
       If Me.Point(newX, newY) = vbBlack Then
            Snow(i).Y = newY
            Snow(i).X = newX
       Else
            If Snow(i).iStopped = 10 Then ' if stopped 10 times, make new!
                
                ' Move according to basic SNOW RULE:
                If Me.Point(Snow(i).X + 1, Snow(i).Y + 1) = vbBlack Then
                   Snow(i).X = Snow(i).X + 1
                   Snow(i).Y = Snow(i).Y + 1
                   Snow(i).iStopped = 0
                ElseIf Me.Point(Snow(i).X - 1, Snow(i).Y + 1) = vbBlack Then
                   Snow(i).X = Snow(i).X - 1
                   Snow(i).Y = Snow(i).Y + 1
                   Snow(i).iStopped = 0
                Else
                   newParticle (i)
                End If
                
            Else
                Snow(i).iStopped = Snow(i).iStopped + 1
            End If
       End If
              
       If (Snow(i).Y) >= Me.ScaleHeight Then
              newParticle (i)
       End If
       
    Next i
    
    DoEvents
Loop
    
End Sub

Sub newParticle(i As Integer)
    Snow(i).X = CInt(Int(Me.ScaleWidth * Rnd))
    Snow(i).Y = 0
    Snow(i).oldX = 0
    Snow(i).oldY = 0
    Snow(i).iStopped = 0
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Me.PSet (X, Y)
    bMOUSE_DOWN = True
    fMouseDown_X = X
    fMouseDown_Y = Y
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    If bMOUSE_DOWN Then
        Dim oldDW As Long
        Dim oldFC As Long
        oldDW = Me.DrawWidth
        oldFC = Me.ForeColor
        Me.DrawWidth = 3
        Me.ForeColor = vbRed
        Me.Line (fMouseDown_X, fMouseDown_Y)-(X, Y)
        fMouseDown_X = X
        fMouseDown_Y = Y
        Me.DrawWidth = oldDW
        Me.ForeColor = oldFC
    End If
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    bMOUSE_DOWN = False
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    bRUN = False
End Sub

Private Sub Timer1_Timer()
    DrawSnow
End Sub
